#include <stdio.h>
#include <stdlib.h>
long long int odz[75000];
long long int nodz[75000];
int main()
{

int t;
scanf("%i",&t);
int n,m;
int i,j;
int a;
int niz[t];
for(a=0;a<t;a++){
        scanf("%i",&n);
        scanf("%i",&m);

          long long int pom;
          long long int min;
          long long int del;
        niz[a] = 1;
    for(i=0;i<n;i++){
        scanf("%lli",&odz[i]);

    }

    if(odz[0]>odz[1])
            min = odz[0]-odz[1];
            else
            min = odz[1]-odz[0];
    del = odz[0] % min;
    for(i=0;i<n;i++){
        for(j=i + 1;j<n;j++){
            if(odz[i]>odz[j])
            pom = odz[i]-odz[j];
            else
            pom = odz[j]-odz[i];
            if (min>pom){
                min = pom;
                del = odz[i] % min;

            }
        }
    }


    for(i=0;i<n;i++){
        if(odz[i]%min != del){
            niz[a] = 0;
            break;
        }
    }

    for(j=0;j<m;j++){
        scanf("%lli",&nodz[j]);
        if(nodz[j]%min == del){
            niz[a] = 0;

        }
    }


}


for(i=0;i<t;i++){
    printf("%i\n",niz[i]);

}




    return 0;
}